Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator.cs	(revision 17547)
+++ 	(revision )
@@ -1,92 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Collections.Generic;
-using HEAL.Attic;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Regression {
-  [Item("Pearson R² Constraint Evaluator", "Calculates the square of the pearson correlation coefficient (also known as coefficient of determination) of a symbolic regression solution.")]
-  [StorableType("D61462E4-2032-4790-B63D-5E6512987F64")]
-  public class SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator : SymbolicRegressionSingleObjectiveEvaluator {
-    [StorableConstructor]
-    protected SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator(StorableConstructorFlag _) : base(_) { }
-    protected SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator(SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator(this, cloner);
-    }
-
-    public SymbolicRegressionSingleObjectiveConstraintPearsonRSquaredEvaluator() : base() { }
-
-    public override bool Maximization { get { return true; } }
-
-    public override IOperation InstrumentedApply() {
-      var solution = SymbolicExpressionTreeParameter.ActualValue;
-      IEnumerable<int> rows = GenerateRowsToEvaluate();
-
-      double quality = Calculate(SymbolicDataAnalysisTreeInterpreterParameter.ActualValue, solution, EstimationLimitsParameter.ActualValue.Lower, EstimationLimitsParameter.ActualValue.Upper, ProblemDataParameter.ActualValue, rows, ApplyLinearScalingParameter.ActualValue.Value);
-      QualityParameter.ActualValue = new DoubleValue(quality);
-      return base.InstrumentedApply();
-    }
-
-    public static double Calculate(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, ISymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, IRegressionProblemData problemData, IEnumerable<int> rows, bool applyLinearScaling) {
-      IEnumerable<double> estimatedValues = interpreter.GetSymbolicExpressionTreeValues(solution, problemData.Dataset, rows);
-      IEnumerable<double> targetValues = problemData.Dataset.GetDoubleValues(problemData.TargetVariable, rows);
-      OnlineCalculatorError errorState = OnlineCalculatorError.None;
-
-      var constraints = problemData.IntervalConstraints.EnabledConstraints;
-      var variableRanges = problemData.VariableRanges.GetIntervals();
-      var tree = solution;
-
-      if (!SymbolicRegressionConstraintAnalyzer.ConstraintsSatisfied(constraints, variableRanges, tree)) {
-        return 0;
-      }
-
-      var r2 = SymbolicRegressionSingleObjectivePearsonRSquaredEvaluator.Calculate(interpreter, solution, lowerEstimationLimit,
-        upperEstimationLimit, problemData, rows, applyLinearScaling);
-
-      return r2;
-    }
-
-
-    public override double Evaluate(IExecutionContext context, ISymbolicExpressionTree tree,
-      IRegressionProblemData problemData, IEnumerable<int> rows) {
-      SymbolicDataAnalysisTreeInterpreterParameter.ExecutionContext = context;
-      EstimationLimitsParameter.ExecutionContext = context;
-      ApplyLinearScalingParameter.ExecutionContext = context;
-
-      double r2 = Calculate(SymbolicDataAnalysisTreeInterpreterParameter.ActualValue, tree,
-        EstimationLimitsParameter.ActualValue.Lower, EstimationLimitsParameter.ActualValue.Upper, problemData, rows,
-        ApplyLinearScalingParameter.ActualValue.Value);
-
-      SymbolicDataAnalysisTreeInterpreterParameter.ExecutionContext = null;
-      EstimationLimitsParameter.ExecutionContext = null;
-      ApplyLinearScalingParameter.ExecutionContext = null;
-
-      return r2;
-    }
-  }
-}
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionConstraintAnalyzer.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionConstraintAnalyzer.cs	(revision 17547)
+++ 	(revision )
@@ -1,139 +1,0 @@
-﻿#region License Information
-
-/* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using HEAL.Attic;
-using HeuristicLab.Analysis;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Regression {
-  [StorableType("4318C6BD-E0A1-45FE-AC30-96E7F73B51FB")]
-  public class SymbolicRegressionConstraintAnalyzer : SymbolicDataAnalysisAnalyzer, ISymbolicExpressionTreeAnalyzer {
-    private const string ConstraintViolationsResultName = "Constraint Violations";
-    private const string ProblemDataParameterName = "ProblemData";
-    private const string ConstraintViolationParameterName = "ConstraintViolations";
-
-    #region parameter properties
-    public ILookupParameter<IRegressionProblemData> RegressionProblemDataParameter {
-      get { return (ILookupParameter<IRegressionProblemData>) Parameters[ProblemDataParameterName]; }
-    }
-
-    public IResultParameter<DataTable> ConstraintViolationParameter =>
-      (IResultParameter<DataTable>) Parameters[ConstraintViolationParameterName];
-    #endregion
-
-    public override bool EnabledByDefault => false;
-
-    [StorableConstructor]
-    protected SymbolicRegressionConstraintAnalyzer(StorableConstructorFlag _) : base(_) {
-    }
-
-    protected SymbolicRegressionConstraintAnalyzer(SymbolicRegressionConstraintAnalyzer original, Cloner cloner) : base(original, cloner) {
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new SymbolicRegressionConstraintAnalyzer(this, cloner);
-    }
-
-    public SymbolicRegressionConstraintAnalyzer() : base(){
-      Parameters.Add(new LookupParameter<IRegressionProblemData>(ProblemDataParameterName, "The problem data of the symbolic data analysis problem."));
-      Parameters.Add(new ResultParameter<DataTable>(ConstraintViolationParameterName, "Shows the number of constraint violations!"));
-      ConstraintViolationParameter.DefaultValue = new DataTable(ConstraintViolationParameterName) {
-        VisualProperties = {
-          XAxisTitle = "Generations",
-          YAxisTitle = "Constraint Violations",
-        }
-      };
-    }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-    }
-
-    public override IOperation Apply() {
-      var problemData = RegressionProblemDataParameter.ActualValue;
-      var trees = SymbolicExpressionTreeParameter.ActualValue;
-
-      var results = ResultCollectionParameter.ActualValue;
-      var constraints = problemData.IntervalConstraints.EnabledConstraints;
-      var variableRanges = problemData.VariableRanges.GetIntervals();
-      var newDataTable = ConstraintViolationParameter.ActualValue;
-
-      if(newDataTable.Rows.Count == 0) { 
-        foreach (var constraint in constraints) {
-          newDataTable.Rows.Add(new DataRow(constraint.Expression));
-        }
-      }
-
-      var interpreter = new IntervalInterpreter();
-      foreach (var constraint in constraints) {
-        var violations = trees.Select(tree => SymbolicRegressionConstraintAnalyzer.ConstraintSatisfied(constraint, interpreter, variableRanges, tree)).Count(satisfied => !satisfied);
-        newDataTable.Rows[constraint.Expression].Values.Add(violations);
-      }
-      
-      return base.Apply();
-    }
-
-    public static bool ConstraintSatisfied(IntervalConstraint constraint, IntervalInterpreter intervalInterpreter,
-      IDictionary<string, Interval> variableRanges, ISymbolicExpressionTree solution) {
-
-      if (constraint.Variable != null && !variableRanges.ContainsKey(constraint.Variable))
-        throw new ArgumentException($"The given variable {constraint.Variable} in the constraint does not exists in the model.", nameof(IntervalConstraintsParser));
-
-      Interval resultInterval;
-
-      if (!constraint.IsDerivative) {
-        resultInterval = intervalInterpreter.GetSymbolicExpressionTreeInterval(solution, variableRanges);
-      } else {
-        var tree = solution;
-        for (var i = 0; i < constraint.NumberOfDerivations; ++i) {
-          if (!IntervalInterpreter.IsCompatible(tree) || !DerivativeCalculator.IsCompatible(tree))
-            throw new ArgumentException("Cube, Root, Power Symbols are not supported.");
-          tree = DerivativeCalculator.Derive(tree, constraint.Variable);
-        }
-        resultInterval = intervalInterpreter.GetSymbolicExpressionTreeInterval(tree, variableRanges);
-      }
-
-      var satisfied = constraint.Interval.Contains(resultInterval);
-      return satisfied;
-    }
-
-    public static bool ConstraintsSatisfied(IEnumerable<IntervalConstraint> constraints, IDictionary<string, Interval> variableRanges, ISymbolicExpressionTree solution) {
-      var intervalInterpreter = new IntervalInterpreter();
-      foreach (var constraint in constraints) {
-        if (constraint.Variable != null && !variableRanges.ContainsKey(constraint.Variable))
-          throw new ArgumentException($"The given variable {constraint.Variable} in the constraint does not exists in the model.", nameof(IntervalConstraintsParser));
-
-        var satisfied = ConstraintSatisfied(constraint, intervalInterpreter, variableRanges, solution);
-        if (!satisfied) return false;
-      }
-      return true;
-    }
-  }
-}
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/ProblemDataConstraintView.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/ProblemDataConstraintView.cs	(revision 17547)
+++ 	(revision )
@@ -1,153 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-using System;
-using System.Collections.Generic;
-using System.Drawing;
-using HeuristicLab.Collections;
-using HeuristicLab.Core;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-
-namespace HeuristicLab.Problems.DataAnalysis.Views {
-  [View("ProblemDataConstraint View")]
-  [Content(typeof(ProblemDataConstraint), true)]
-  public partial class ProblemDataConstraintView : AsynchronousContentView {
-    private readonly CheckedItemList<IntervalConstraint> intervalConstraints = new CheckedItemList<IntervalConstraint>();
-    public new ProblemDataConstraint Content {
-      get => (ProblemDataConstraint)base.Content;
-      set => base.Content = value;
-    }
-
-    public ProblemDataConstraintView() {
-      InitializeComponent();
-      errorOutput.Text = "";
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      UpdateControl();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      intervalConstraints.CheckedItemsChanged += constraint_CheckedItemChanged;
-      intervalConstraints.ItemsAdded += constraints_Updated;
-      intervalConstraints.ItemsRemoved += constraint_removed;
-      Content.Changed += Content_Changed;
-    }
-
-    protected override void DeregisterContentEvents() {
-      intervalConstraints.CheckedItemsChanged -= constraint_CheckedItemChanged;
-      intervalConstraints.ItemsAdded -= constraints_Updated;
-      intervalConstraints.ItemsRemoved -= constraint_removed;
-      Content.Changed -= Content_Changed;
-      base.DeregisterContentEvents();
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      constraintsInput.Enabled = Content != null && !Locked && !ReadOnly;
-    }
-
-
-    private IEnumerable<IntervalConstraint> ParseConstraints(string input) {
-        return IntervalConstraintsParser.ParseInput(input, Content.ProblemData.TargetVariable,
-          Content.ProblemData.AllowedInputVariables);
-    }
-
-    private void parseBtn_Click(object sender, EventArgs e) {
-      if (constraintsInput.Text != null) {
-        intervalConstraints.Clear();
-        try {
-          var parsedConstraints = ParseConstraints(constraintsInput.Text);
-          Content.Constraints = parsedConstraints;
-          Content.Input = constraintsInput.Text;
-          Content.InfoText = "Constraints successfully parsed.";
-          Content.InfoColor = Color.DarkGreen;
-          //Catch the exception from the constraints parser and show it in the error dialog
-        } catch(ArgumentException ex) {
-          Content.Constraints = new List<IntervalConstraint>();
-          Content.InfoText = ex.Message.Replace("Parameter name", "@Line");
-          Content.InfoColor = Color.DarkRed;
-        }
-      } else {
-        errorOutput.Text = "No constraints were found!";
-      }
-    }
-
-    private void UpdateControl() {
-      if (Content == null) {
-        intervalConstraints.Clear();
-        intervalConstraintsView.Content = intervalConstraints;
-      } else {
-        intervalConstraints.Clear();
-        constraintsInput.Text = Content.Input;
-        errorOutput.ForeColor = Content.InfoColor;
-        errorOutput.Text = Content.InfoText;
-        foreach (var constraint in Content.Constraints) {
-          intervalConstraints.Add(constraint, constraint.Enabled);
-        }
-
-        intervalConstraintsView.Content = intervalConstraints;
-      }
-    }
-
-    private void constraint_Changed(object sender, EventArgs e) {
-      var constraint = (IntervalConstraint)sender;
-      intervalConstraints.SetItemCheckedState(constraint, constraint.Enabled);
-    }
-
-    private void constraints_Updated(object sender, CollectionItemsChangedEventArgs<IndexedItem<IntervalConstraint>> e) {
-      foreach (var addedItem in e.Items) {
-        addedItem.Value.Changed += constraint_Changed;
-      }
-    }
-
-    private void constraint_removed(object sender, CollectionItemsChangedEventArgs<IndexedItem<IntervalConstraint>> e) {
-      foreach (var removedItem in e.Items) {
-        removedItem.Value.Changed -= constraint_Changed;
-      }
-    }
-
-    private void constraint_CheckedItemChanged(object sender,
-      CollectionItemsChangedEventArgs<IndexedItem<IntervalConstraint>> e) {
-      ICheckedItemList<IntervalConstraint> checkedItemList = (ICheckedItemList<IntervalConstraint>)sender;
-      foreach (var indexedItem in e.Items) {
-        indexedItem.Value.Enabled = checkedItemList.ItemChecked(indexedItem.Value);
-      }
-    }
-
-    private void constraintsInput_TextChanged(object sender, EventArgs e) {
-      if (Content.Input != constraintsInput.Text) {
-       Content.Input = constraintsInput.Text;
-       Content.InfoText = "Unparsed changes! Press parse button to save changes.";
-       Content.InfoColor = Color.DarkOrange;
-      } else {
-        errorOutput.Text = "";
-      }
-
-    }
-
-    private void Content_Changed(object sender, EventArgs e) {
-      UpdateControl();
-    }
-
-  }
-}
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/ProblemDataConstraintView.designer.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/ProblemDataConstraintView.designer.cs	(revision 17547)
+++ 	(revision )
@@ -1,188 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-using System;
-using System.Drawing;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-
-namespace HeuristicLab.Problems.DataAnalysis.Views {
-  partial class ProblemDataConstraintView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ProblemDataConstraintView));
-      this.splitContainer1 = new System.Windows.Forms.SplitContainer();
-      this.groupBox1 = new System.Windows.Forms.GroupBox();
-      this.constraintsInput = new System.Windows.Forms.TextBox();
-      this.parseBtn = new System.Windows.Forms.Button();
-      this.errorOutput = new System.Windows.Forms.Label();
-      this.label1 = new System.Windows.Forms.Label();
-      this.intervalConstraintsView = new CheckedItemListView<IntervalConstraint>();
-      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
-      this.splitContainer1.Panel1.SuspendLayout();
-      this.splitContainer1.Panel2.SuspendLayout();
-      this.splitContainer1.SuspendLayout();
-      this.groupBox1.SuspendLayout();
-      this.SuspendLayout();
-      // 
-      // splitContainer1
-      // 
-      this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.splitContainer1.Location = new System.Drawing.Point(0, 0);
-      this.splitContainer1.Name = "splitContainer1";
-      // 
-      // splitContainer1.Panel1
-      // 
-      this.splitContainer1.Panel1.Controls.Add(this.groupBox1);
-      // 
-      // splitContainer1.Panel2
-      // 
-      this.splitContainer1.Panel2.Controls.Add(this.intervalConstraintsView);
-      this.splitContainer1.Size = new System.Drawing.Size(888, 629);
-      this.splitContainer1.SplitterDistance = 296;
-      this.splitContainer1.TabIndex = 0;
-      // 
-      // groupBox1
-      // 
-      this.groupBox1.Controls.Add(this.constraintsInput);
-      this.groupBox1.Controls.Add(this.parseBtn);
-      this.groupBox1.Controls.Add(this.errorOutput);
-      this.groupBox1.Controls.Add(this.label1);
-      this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.groupBox1.Location = new System.Drawing.Point(0, 0);
-      this.groupBox1.Name = "groupBox1";
-      this.groupBox1.Size = new System.Drawing.Size(296, 629);
-      this.groupBox1.TabIndex = 3;
-      this.groupBox1.TabStop = false;
-      this.groupBox1.Text = "Constraints Input";
-      // 
-      // constraintsInput
-      // 
-      this.constraintsInput.AcceptsTab = true;
-      this.constraintsInput.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.constraintsInput.Location = new System.Drawing.Point(3, 185);
-      this.constraintsInput.Multiline = true;
-      this.constraintsInput.Name = "constraintsInput";
-      this.constraintsInput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
-      this.constraintsInput.Size = new System.Drawing.Size(290, 405);
-      this.constraintsInput.TabIndex = 2;
-      this.constraintsInput.TextChanged += new System.EventHandler(this.constraintsInput_TextChanged);
-      // 
-      // parseBtn
-      // 
-      this.parseBtn.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.parseBtn.Location = new System.Drawing.Point(3, 590);
-      this.parseBtn.Name = "parseBtn";
-      this.parseBtn.Size = new System.Drawing.Size(290, 23);
-      this.parseBtn.TabIndex = 1;
-      this.parseBtn.Text = "Parse Constraints";
-      this.parseBtn.UseVisualStyleBackColor = true;
-      this.parseBtn.Click += new System.EventHandler(this.parseBtn_Click);
-      // 
-      // errorOutput
-      // 
-      this.errorOutput.MaximumSize = new Size(350, 0);
-      this.errorOutput.AutoSize = true;
-      this.errorOutput.ForeColor = Color.DarkRed;
-      this.errorOutput.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.errorOutput.Location = new System.Drawing.Point(3, 613);
-      this.errorOutput.Name = "errorOutput";
-      this.errorOutput.Size = new System.Drawing.Size(35, 13);
-      this.errorOutput.TabIndex = 3;
-      this.errorOutput.Text = "label2";
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Dock = System.Windows.Forms.DockStyle.Top;
-      this.label1.Location = new System.Drawing.Point(3, 16);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(354, 169);
-      this.label1.TabIndex = 0;
-      this.label1.Text = "To define target variable constraints:" + Environment.NewLine +
-                         "1. Start the definition with target:" + Environment.NewLine +
-                         "2. Specify the target variable between '-characters" + Environment.NewLine +
-                         "3. Add the keyword in" + Environment.NewLine +
-                         "4. Specify the interval with [lowerbound .. upperbound]" + Environment.NewLine +
-                         "To define a derivation constraint: " + Environment.NewLine +
-                         "1. Start with d or \u2202" + Environment.NewLine +
-                         "2. Specify the target between '-characters" + Environment.NewLine +
-                         "3. Separate target and derivation variable with /" + Environment.NewLine +
-                         "4. Add derivation variable between '-characters'" + Environment.NewLine +
-                         "5. Follow the steps 3-4 from above";
-      // 
-      // intervalConstraintsView
-      // 
-      this.intervalConstraintsView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.intervalConstraintsView.Location = new System.Drawing.Point(0, 0);
-      this.intervalConstraintsView.Name = "intervalConstraintsView";
-      this.intervalConstraintsView.Size = new System.Drawing.Size(588, 20);
-      this.intervalConstraintsView.TabIndex = 2;
-      // 
-      // ProblemDataConstraintView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.splitContainer1);
-      this.Name = "ProblemDataConstraintView";
-      this.Size = new System.Drawing.Size(888, 629);
-      this.splitContainer1.Panel1.ResumeLayout(false);
-      this.splitContainer1.Panel2.ResumeLayout(false);
-      this.splitContainer1.Panel2.PerformLayout();
-      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
-      this.splitContainer1.ResumeLayout(false);
-      this.groupBox1.ResumeLayout(false);
-      this.groupBox1.PerformLayout();
-      this.ResumeLayout(false);
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.SplitContainer splitContainer1;
-    private System.Windows.Forms.GroupBox groupBox1;
-    private System.Windows.Forms.Button parseBtn;
-    private System.Windows.Forms.Label label1;
-    private HeuristicLab.Core.Views.CheckedItemListView<IntervalConstraint> intervalConstraintsView;
-    private System.Windows.Forms.TextBox constraintsInput;
-    private Label errorOutput;
-  }
-}
Index: branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs
===================================================================
--- branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/ProblemDataConstraint.cs	(revision 17547)
+++ 	(revision )
@@ -1,131 +1,0 @@
-﻿#region License Information
-
-/* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-
-#endregion
-using System;
-using System.Collections.Generic;
-using System.Drawing;
-using System.Linq;
-using HEAL.Attic;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Problems.DataAnalysis {
-  [StorableType("A56BFB05-8F11-4766-9FBF-20C7010F1CA3")]
-  [Item("ProblemDataConstraints", "Represents constraints associated with a problem data.")]
-  public class ProblemDataConstraint : Item {
-    private static readonly string exampleInput = "# Example for a target variable constraint:" + Environment.NewLine +
-                                                  "Target:'y' in [0 .. 100]" + Environment.NewLine + Environment.NewLine +
-                                                  "# Example for constraints on model parameters: " + Environment.NewLine +
-                                                  "d'y'/d'x' in [0 .. 10]" + Environment.NewLine +
-                                                  "∂²'y'/∂'x'² in [-1 .. inf.]";
-
-    [Storable]
-    private string input;
-    public string Input {
-      get => input;
-      set {
-        if (input == value) return;
-        input = value;
-        OnChanged();
-      }
-    }
-
-    [Storable]
-    private string infoText;
-    public string InfoText {
-      get => infoText;
-      set {
-        if (infoText == value) return;
-        infoText = value;
-        OnChanged();
-      }
-    }
-
-    [Storable]
-    private Color infoColor;
-    public Color InfoColor {
-      get => infoColor;
-      set {
-        if (infoColor == value) return;
-        infoColor = value;
-        OnChanged();
-      }
-    }
-
-    [Storable]
-    private IEnumerable<IntervalConstraint> constraints;
-    public IEnumerable<IntervalConstraint> Constraints {
-      get => constraints;
-      set {
-        if (constraints == value) return;
-        constraints = value.ToList();
-        OnChanged();
-      }
-    }
-    public IEnumerable<IntervalConstraint> EnabledConstraints {
-      get => Constraints.Where(c => c.Enabled);
-    }
-
-
-    [Storable]
-    public IRegressionProblemData ProblemData { get; private set; }
-
-    [StorableConstructor]
-    protected ProblemDataConstraint(StorableConstructorFlag _) : base(_) { }
-
-    protected ProblemDataConstraint(ProblemDataConstraint original, Cloner cloner)
-      : base(original, cloner) {
-      this.Input = original.Input;
-      this.InfoText = original.InfoText;
-      this.infoColor = original.InfoColor;
-      this.constraints = original.Constraints.Select(cloner.Clone).ToList();
-      this.ProblemData = cloner.Clone(original.ProblemData);
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new ProblemDataConstraint(this, cloner);
-    }
-
-    public ProblemDataConstraint() : base() {
-      this.Input = exampleInput;
-      this.InfoText = "";
-      this.InfoColor = Color.DarkOrange;
-      this.constraints = new List<IntervalConstraint>();
-      this.ProblemData = null;
-    }
-
-    public ProblemDataConstraint(IRegressionProblemData problemData) : base() {
-      this.Input = exampleInput;
-      this.InfoText = infoText;
-      this.InfoColor = InfoColor;
-      this.constraints = new List<IntervalConstraint>();
-      this.ProblemData = problemData;
-    }
-
-    public event EventHandler Changed;
-    protected virtual void OnChanged() {
-      EventHandler handlers = Changed;
-      if (handlers != null)
-        handlers(this, EventArgs.Empty);
-    }
-  }
-}